# $Id: tmp_itertools.py 44 2007-11-08 18:17:27Z mtnyogi $
# coding=utf-8
# 
# Copyright © 2007 Bruce Frederiksen
# 
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
# 
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.

''' This is a placeholder until the standard python itertools changes its
'chain' function to take a single argument (like this one here).
'''

import itertools

def chain(iterables):
    for iterable in iterables:
        for x in iterable: yield x

count = itertools.count
cycle = itertools.cycle
dropwhile = itertools.dropwhile
groupby = itertools.groupby
ifilterfalse = itertools.ifilterfalse
ifilter = itertools.ifilter
imap = itertools.imap
islice = itertools.islice
izip = itertools.izip
repeat = itertools.repeat
starmap = itertools.starmap
takewhile = itertools.takewhile
tee = itertools.tee

def test():
    import doctest
    import sys
    sys.exit(doctest.testmod()[0])

if __name__ == "__main__":
    test()
